import { AsyncSubject } from 'rxjs/AsyncSubject';
import * as _ from 'lodash-es';
import { originalGetterSetter } from '../../src/store-lookup.func';
export const ApSubjectAsyncInit = function (target, properties) {
    if (properties instanceof Array) {
        const lookup = { getter: {}, setter: {} };
        _.each(properties, (property) => {
            originalGetterSetter(lookup, target, property);
            Object.defineProperty(target.prototype, `_${property}$`, { writable: true });
            Object.defineProperty(target.prototype, `${property}$`, {
                set: function (value) {
                    this[`_${property}$`] = value;
                },
                get: function () {
                    if (this[`_${property}$`] === undefined) {
                        this[`_${property}$`] = new AsyncSubject();
                    }
                    return this[`_${property}$`];
                }
            });
            Object.defineProperty(target.prototype, property, {
                set: function (value) {
                    if (this[`${property}$`]) {
                        this[`${property}$`].next(value);
                    }
                    if (lookup.setter[property] !== undefined) {
                        lookup.setter[property].apply(this, arguments);
                    }
                },
                get: function () {
                    return this[`${property}$`];
                }
            });
        });
    }
};
//# sourceMappingURL=subject-async-init.func.js.map