import { Subject } from 'rxjs/Subject';
import * as _ from 'lodash-es';
import { completeFunction } from './complete.function';
import { subscribeFunction } from './subscribe.function';
import { originalGetterSetter } from './store-lookup.func';
export const ApSubjectInit = function (target, properties) {
    const lookup = { getter: {}, setter: {} };
    if (properties instanceof Array) {
        _.each(properties, (property) => {
            originalGetterSetter(lookup, target, property);
            Object.defineProperty(target.prototype, `_${property}`, { writable: true });
            Object.defineProperty(target.prototype, `_${property}$`, { writable: true });
            Object.defineProperty(target.prototype, `${property}$`, {
                set: function (value) {
                    this[`_${property}$`] = value;
                },
                get: function () {
                    if (this[`_${property}$`] === undefined) {
                        this[`_${property}$`] = new Subject();
                    }
                    return this[`_${property}$`];
                }
            });
            subscribeFunction(target);
            completeFunction(target);
            Object.defineProperty(target.prototype, `${property}`, {
                set: function (value) {
                    if (this[`${property}$`]) {
                        this[`${property}$`].next(value);
                    }
                    if (lookup.setter[property] === undefined) {
                        this[`_${property}`] = value;
                    }
                    else {
                        lookup.setter[property].apply(this, arguments);
                    }
                },
                get: function () {
                    if (lookup.getter[property] === undefined) {
                        return this[`_${property}`];
                    }
                    else {
                        return lookup.getter[property].apply(this, arguments);
                    }
                }
            });
        });
    }
};
//# sourceMappingURL=subject-init.func.js.map