import { Subscription } from 'rxjs/Subscription';
import * as _ from 'lodash-es';
export const ApUnsubscribeOnDestroy = function (target, properties) {
    if (target.prototype.ngOnDestroy !== undefined) {
        const ngOnDestroy = target.prototype.ngOnDestroy;
        target.prototype.ngOnDestroy = function () {
            if (properties === undefined) {
                _.each(this, (subscription) => {
                    if (subscription instanceof Subscription && subscription.closed === false) {
                        subscription.unsubscribe();
                    }
                });
            }
            else {
                _.each(this, (subscription, key) => {
                    _.each(properties, (observableName) => {
                        if (key.includes(observableName)) {
                            if (subscription instanceof Subscription && subscription.closed === false) {
                                subscription.unsubscribe();
                            }
                        }
                    });
                });
            }
            if (ngOnDestroy !== undefined) {
                ngOnDestroy.apply(this, arguments);
            }
        };
    }
};
//# sourceMappingURL=unsubscribe-ondestroy.func.js.map